.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\shell32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shlwapi.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\shlwapi.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
Msgbox proto :DWORD,:DWORD
GetWinampText proto 
ParseWinampText proto 



.data
ClassName db "SimpleWinClass",0
ButtonClass db "Button", 0
EditClass db "Edit", 0
AppName  db "Parse",0
WinampClass db "Winamp v1.x", 0
ErrorTitle db "Error", 0
Error1 db "Error 1 : Unable to find the Winamp window", 0
Error2 db "Error 2  : Error getting the text from Winamp", 0
Error3 db "Error 3 : Error getting the text from Winamp", 0
Text1 db "Ash_'s Winamp Text Parser", 0
WINAMP_TITLE_BEGIN db ". ",0
WINAMP_TITLE_MIDDLE db " - ",0
WINAMP_TITLE_END db "- Winamp",0
artist DWORD 1
songtitle DWORD 1
playing DWORD 1
songIndexStr DWORD 1
.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
Textbox HWND ?
ArtistBox HWND ?
SongTitleBox HWND ?
PlayingBox HWND ?
SongIndexBox HWND ?
hText db 512 dup(?)

.const
Command1 equ 3000
Icon equ 500
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,Icon
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,345,200,NULL,NULL,\
           hInst,NULL

	mov   hwnd,eax
	INVOKE CreateWindowEx,NULL,ADDR ButtonClass,ADDR AppName,\
           WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,10,\
           10,60,150,hwnd,Command1,\
           hInst,NULL
      INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClass, addr Text1,\
             WS_CHILD or WS_VISIBLE or ES_WANTRETURN or ES_CENTER or ES_AUTOHSCROLL or ES_READONLY,\
             75, 10, 255, 25, hwnd,NULL,hInst,NULL
       mov Textbox, eax
             INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClass, NULL,\
             WS_CHILD or WS_VISIBLE or ES_WANTRETURN or ES_LEFT or ES_AUTOHSCROLL,\
             75, 40, 255, 25, hwnd,NULL,hInst,NULL
       mov ArtistBox, eax
             INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClass, NULL,\
             WS_CHILD or WS_VISIBLE or ES_WANTRETURN or ES_LEFT or ES_AUTOHSCROLL,\
             75, 70, 255, 25, hwnd,NULL,hInst,NULL
       mov SongTitleBox, eax
             INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClass, NULL,\
             WS_CHILD or WS_VISIBLE or ES_WANTRETURN or ES_LEFT or ES_AUTOHSCROLL,\
             75, 100, 255, 25, hwnd,NULL,hInst,NULL
       mov PlayingBox, eax
             INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClass, NULL,\
             WS_CHILD or WS_VISIBLE or ES_WANTRETURN or ES_LEFT or ES_AUTOHSCROLL,\
             75, 130, 255, 25, hwnd,NULL,hInst,NULL
       mov SongIndexBox, eax
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
Msgbox proc Caption:DWORD, Text:DWORD
invoke MessageBox,0,Text,Caption,0
ret
Msgbox endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM


	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
      .ELSEIF uMsg==WM_COMMAND
      mov eax,wParam
    .if ax==Command1
    invoke GetWinampText
    invoke ParseWinampText
    .endif
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	xor eax,eax
	ret
WndProc endp
GetWinampText proc
LOCAL hWinamp:HWND
LOCAL hLength:DWORD

invoke FindWindow,addr WinampClass, NULL
.if(!eax)
    invoke MessageBox,0,addr Error1,addr ErrorTitle,MB_OK
    invoke ExitProcess,0
.endif
mov hWinamp,eax
invoke GetWindowTextLength,hWinamp
.if(!eax)
    invoke MessageBox,0,addr Error2,addr ErrorTitle,MB_OK
    invoke ExitProcess,0
.endif
mov hLength,eax
add hLength, 1
invoke GetWindowText,hWinamp,addr hText,hLength
.if(!eax)
    invoke MessageBox,0,addr Error3,addr ErrorTitle,MB_OK
    invoke ExitProcess,0
.endif


ret
GetWinampText endp
ParseWinampText proc
LOCAL afterIndexStr:DWORD
LOCAL afterArtistStr:DWORD
LOCAL afterTitleStr:DWORD
LOCAL textLength:DWORD
LOCAL afterIndexLength:DWORD
LOCAL afterArtistLength:DWORD
LOCAL afterTitleLength:DWORD
LOCAL titleMiddleLength:DWORD
LOCAL songIndexLength:DWORD
LOCAL artistLength:DWORD
LOCAL titleLength:DWORD
LOCAL playingLength:DWORD



invoke lstrlen, addr hText
mov textLength, eax
invoke StrStr,addr hText,addr WINAMP_TITLE_BEGIN
add eax, 2
mov afterIndexStr, eax
invoke StrStr,addr hText,addr WINAMP_TITLE_MIDDLE
add eax, 3
mov afterArtistStr, eax
invoke StrStr,addr hText,addr WINAMP_TITLE_END
add eax, 8
mov afterTitleStr, eax

invoke lstrlen, afterIndexStr
mov afterIndexLength,eax
invoke lstrlen, afterArtistStr
mov afterArtistLength, eax
invoke lstrlen, afterTitleStr
mov afterTitleLength, eax
invoke lstrlen,addr WINAMP_TITLE_MIDDLE
mov titleMiddleLength, eax

mov eax, textLength
sub eax, afterIndexLength
sub eax, 1
mov songIndexLength, eax
mov eax, afterIndexLength
sub eax, afterArtistLength
sub eax, titleMiddleLength
add eax,1
mov artistLength, eax
mov eax, afterArtistLength
sub eax, afterTitleLength
sub eax, 7
mov titleLength, eax
mov eax, afterIndexLength
sub eax, afterTitleLength
add eax,1
mov playingLength, eax


invoke lstrcpyn, addr artist, afterIndexStr, artistLength
invoke SetWindowText, ArtistBox, addr artist
invoke lstrcpyn, addr songtitle, afterArtistStr, titleLength
invoke SetWindowText, SongTitleBox, addr songtitle
invoke lstrcpyn, addr playing, afterIndexStr, playingLength
invoke SetWindowText, PlayingBox, addr songtitle
invoke lstrcpyn, addr songIndexStr, addr hText, songIndexLength
invoke SetWindowText, SongIndexBox, addr songIndexStr

xor afterIndexStr,eax
xor afterArtistStr,eax
xor afterTitleStr,eax

ret
ParseWinampText endp
end start
